#include "Arena.h"

Arena::Arena(int _x, int _y, int _w, int _h)
: x(_x), y(_y), w(_w), h(_h)
{
    for(int i = 0; i < _w; i++)
        for(int j = 0; j < _h; j++)
            if(isPair(i + 1) && isPair(j + 1))
                addElement(new Wall(i, j));
            else
                addElement(new Grass(i, j));
}

Arena::~Arena()
{
    for(int i = 0; i < w * h; i++)
        if(elements[i])
            delete elements[i];

    elements.clear();
}

void Arena::addElement(ArenaElement* e)
{
    elements.push_back(e);
}

void Arena::load(const char* filename)
{
    DATAFILE* sprites = load_datafile(filename);

    if(!sprites)
    {
        allegro_message("No foi possvel encontrar o arquivo %s.", filename);

        exit(1);
    }

    /*for(int i = 0; i < 13; i++)
        for(int j = 0; j < 11; j++)
            if((i + 1) % 2 == 0 && (j + 1) % 2 == 0)
            {

                stretch_blit((BITMAP*)sprites[12].dat, tiles[i][j].img, 0,0, 32,32, 0,0, 40,40);
            }
            else
            {
                blit((BITMAP*)sprites[13].dat, tiles[i][j].img, 0,0, 0,0, 40,40);
            }*/

    unload_datafile(sprites);
}

void Arena::draw(BITMAP* buffer)
{
    /*for(int i = 0; i < 13; i++)
        for(int j = 0; j < 11; j++)
        {
            draw_sprite(buffer, tiles[i][j].img, x + 40 * i, y + 40 * j);
        }
    for(int i = 0; i < 13; i++)
        for(int j = 0; j < 11; j++)
        {
            vline(buffer, x + i * 40, 0, 11*40, WHITE);
            hline(buffer, y + 0, j*40, 13*40, WHITE);
        }*/

    for(int i = 0; i < elements.size(); i++)
      elements[i]->draw(buffer);

}

bool Arena::free(int x, int y)
{
    return true;
    //if(x < 0 || x > 12 || y < 0 || y > 10)
    //    return false;

    //return tiles[x][y].value == GRASS;
}
