#include "BattleStep.h"

BattleStep::BattleStep(Steps* _step)
: GameStep(_step)
{
    player = new Player;

    arena = new Arena(50, 50, 13, 11);

    arena->addElement(player);

}

BattleStep::~BattleStep()
{
    delete player;

    delete arena;
}

void BattleStep::load()
{
    arena->load("img/player.dat");

    player->load("img/player.dat");
}

void BattleStep::input()
{
    if(keypressed())
    {
        if(key[KEY_ESC])
        {
            quited = true;

            changeToStep(EXIT);
        }

        if(key[KEY_UP] || key[KEY_DOWN] || key[KEY_LEFT] || key[KEY_RIGHT])
        {
            if(key[KEY_UP])
                requestWalk(NORTH);

            else if(key[KEY_DOWN])
                requestWalk(SOUTH);

            else if(key[KEY_LEFT])
                requestWalk(WEST);

            else if(key[KEY_RIGHT])
                requestWalk(EAST);
        }
        else
        {
            player->stop();
        }
    }

    else
    {
        player->stop();
    }
}

void BattleStep::process()
{
    player->process();
}

void BattleStep::draw(BITMAP* buffer)
{
    //clear_to_color(buffer, WHITE);
    clear(buffer);
    arena->draw(buffer);

//    player->Draw(buffer);

    blit(buffer, screen, 0, 0, 0, 0, 640, 480);
}

void BattleStep::unload()
{
    clear_keybuf();
}

void BattleStep::requestWalk(Direction d)
{
    player->setDirection(d);

    int x = player->getX() / 40;

    int y = player->getY() / 40;

    switch(d)
    {
        case NORTH :

            arena->free(x, y - 1) ? player->walk() : player->stop();

            break;

        case SOUTH :

            arena->free(x, y + 1) ? player->walk() : player->stop();

            break;

        case WEST :
            x = (player->getX() + player->width()) / 40;
            arena->free(x - 1, y) ? player->walk() : player->stop();

            break;

        case EAST :

            arena->free(x + 1, y) ? player->walk() : player->stop();

            break;
    }
}
