#include "BitmapLoader.h"

BitmapLoader::BitmapLoader(string _file)
: file(_file)
{
}

BitmapLoader::~BitmapLoader()
{
}

BITMAP* BitmapLoader::getBitmap(BitmapIndex index)
{
    map<int, BITMAP*>::iterator it = bitmaps.find(index);

    if(*it->pointer)
        return it->second;

    DATAFILE* datafile = load_datafile(file.c_str());

    int w = ((BITMAP*)datafile[index].dat)->w;
    int h = ((BITMAP*)datafile[index].dat)->h;

    BITMAP* bmp = create_bitmap(w, h);

    blit((BITMAP*)datafile->dat, bmp, 0, 0, 0, 0, w, h);

    bitmaps[index] = bmp;

    unload_datafile(datafile);
}
