#include "MainMenuStep.h"

MainMenuStep::MainMenuStep(Steps* _step)
: GameStep(_step)
{
    menu = new Menu("MENU", 200, 100);
}

MainMenuStep::~MainMenuStep()
{
    delete menu;
}

void MainMenuStep::load()
{
    menu->add("1 Jogador", ENABLED);
    menu->add("Multijogador", DISABLED);
    menu->add("Opes", ENABLED);
    menu->add("Crditos", ENABLED);
    menu->add("Sair", ENABLED);
}

void MainMenuStep::input()
{
    if(keypressed())
    {
        if(key[KEY_ESC])
        {
            quited = true;

            changeToStep(EXIT);
        }

        if(key[KEY_DOWN])
            menu->next();

        if(key[KEY_UP])
            menu->previous();

        if(key[KEY_ENTER] || key[KEY_ENTER_PAD])
        {
            int choice = menu->getSelected();

            switch(choice)
            {
                case SINGLEPLAYER_CHOICE :

                    changeToStep(SINGLEPLAYER);

                    break;

                case MULTIPLAYER_CHOICE :
                    //*step = MULTIPLAYER;
                    break;

                case OPTIONS_CHOICE :

                    changeToStep(OPTIONS);

                    break;

                case CREDITS_CHOICE :

                    changeToStep(CREDITS);

                    break;

                case EXIT_CHOICE :

                    changeToStep(EXIT);

                    break;

            }

            quited = true;
        }

    }

    clear_keybuf();
}

void MainMenuStep::process()
{
}

void MainMenuStep::draw(BITMAP* buffer)
{
    clear_bitmap(buffer);

    menu->draw(buffer);

    blit(buffer, screen, 0, 0, 0, 0, buffer->w, buffer->h);
}

void MainMenuStep::unload()
{
    menu->removeAll();
}
