#ifndef PLAYER_H
#define PLAYER_H

#include <allegro.h>

#include "ArenaElement.h"
#include "Color.h"
#include "Bomb.h"

#include "Utils.h"

enum PlayerState
{
    STAND,
    WALKING
};

enum Direction
{
    NONE,
    NORTH,
    SOUTH,
    EAST,
    WEST
};

const int WALK_STEP = 4;

class Player : public ArenaElement
{
    int counter;

    Bombs bombs;

    Direction dir;

    PlayerState state;

    BITMAP* front[4];
    BITMAP* back[4];
    BITMAP* left[4];
    BITMAP* right[4];

    BITMAP* current;

    public:

        Player(int _x = 0, int _y = 0);

        ~Player();

        void load(const char* filename);

        void draw(BITMAP* buffer);

        void process();

        void setDirection(Direction d);

        void walk();
        void stop();

        void putBomb();

        int width();
        int height();
};

#endif // BOMBERMAN_H
