#include "PresentsStep.h"

PresentsStep::PresentsStep(Steps* _step)
: GameStep(_step)
{
    background = create_bitmap(SCREEN_W, SCREEN_H);
}

PresentsStep::~PresentsStep()
{
    if(background)
    {
        destroy_bitmap(background);

        background = NULL;
    }
}

void PresentsStep::load()
{
    DATAFILE* bgs = load_datafile("img/backgrounds.dat");

    if(!bgs)
    {
        allegro_message("No foi possvel encontrar o arquivo img/backgrounds.dat.");

        exit(1);
    }

    stretch_blit((BITMAP*)bgs[0].dat, background, 0,0, ((BITMAP*)bgs[0].dat)->w, ((BITMAP*)bgs[0].dat)->h, 0,0, SCREEN_W, SCREEN_H);

    unload_datafile(bgs);
}

void PresentsStep::input()
{
    if(keypressed())
    {
        if(key[KEY_ESC])
        {
            quited = true;

            changeToStep(MAINMENU);
        }
    }

    clear_keybuf();
}

void PresentsStep::process()
{

}

void PresentsStep::draw(BITMAP* buffer)
{
    clear_bitmap(buffer);

    draw_sprite(buffer, background, 0, 0);

    textout_centre_ex(buffer, font, "Pressione ESC para continuar...", 320, 430, WHITE, NO_BGCOLOR);

    blit(buffer, screen, 0, 0, 0, 0, buffer->w, buffer->h);
}

void PresentsStep::unload()
{
}


